/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 79 "cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static void* cmd_tmp;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else 
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 216 "cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CFG_TAB_H_INCLUDED
# define YY_YY_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DROP = 258,
    ASSERT = 259,
    EXIT = 260,
    RETURN = 261,
    LOG_TOK = 262,
    ERROR = 263,
    ROUTE = 264,
    ROUTE_FAILURE = 265,
    ROUTE_ONREPLY = 266,
    ROUTE_BRANCH = 267,
    ROUTE_ERROR = 268,
    ROUTE_LOCAL = 269,
    ROUTE_STARTUP = 270,
    ROUTE_TIMER = 271,
    ROUTE_EVENT = 272,
    IF = 273,
    ELSE = 274,
    SWITCH = 275,
    CASE = 276,
    DEFAULT = 277,
    BREAK = 278,
    WHILE = 279,
    FOR = 280,
    IN = 281,
    NULLV = 282,
    XDBG = 283,
    XLOG = 284,
    XLOG_BUF_SIZE = 285,
    XLOG_FORCE_COLOR = 286,
    XLOG_PRINT_LEVEL = 287,
    XLOG_LEVEL = 288,
    PV_PRINT_BUF_SIZE = 289,
    DEBUG_MODE = 290,
    ENABLE_ASSERTS = 291,
    ABORT_ON_ASSERT = 292,
    LOGLEVEL = 293,
    LOGSTDERROR = 294,
    LOGFACILITY = 295,
    LOGNAME = 296,
    AVP_ALIASES = 297,
    LISTEN = 298,
    SOCKET = 299,
    MEMGROUP = 300,
    ALIAS = 301,
    AUTO_ALIASES = 302,
    TAG = 303,
    DNS = 304,
    REV_DNS = 305,
    DNS_TRY_IPV6 = 306,
    DNS_TRY_NAPTR = 307,
    DNS_RETR_TIME = 308,
    DNS_RETR_NO = 309,
    DNS_SERVERS_NO = 310,
    DNS_USE_SEARCH = 311,
    MAX_WHILE_LOOPS = 312,
    UDP_WORKERS = 313,
    CHECK_VIA = 314,
    SHM_HASH_SPLIT_PERCENTAGE = 315,
    SHM_SECONDARY_HASH_SIZE = 316,
    MEM_WARMING_ENABLED = 317,
    MEM_WARMING_PATTERN_FILE = 318,
    MEM_WARMING_PERCENTAGE = 319,
    RPM_MEM_FILE = 320,
    RPM_MEM_SIZE = 321,
    MEMLOG = 322,
    MEMDUMP = 323,
    EXECMSGTHRESHOLD = 324,
    EXECDNSTHRESHOLD = 325,
    TCPTHRESHOLD = 326,
    EVENT_SHM_THRESHOLD = 327,
    EVENT_PKG_THRESHOLD = 328,
    QUERYBUFFERSIZE = 329,
    QUERYFLUSHTIME = 330,
    SIP_WARNING = 331,
    SERVER_SIGNATURE = 332,
    SERVER_HEADER = 333,
    USER_AGENT_HEADER = 334,
    LOADMODULE = 335,
    MPATH = 336,
    MODPARAM = 337,
    MAXBUFFER = 338,
    CHROOT = 339,
    WDIR = 340,
    MHOMED = 341,
    POLL_METHOD = 342,
    TCP_ACCEPT_ALIASES = 343,
    TCP_WORKERS = 344,
    TCP_CONNECT_TIMEOUT = 345,
    TCP_CON_LIFETIME = 346,
    TCP_LISTEN_BACKLOG = 347,
    TCP_SOCKET_BACKLOG = 348,
    TCP_MAX_CONNECTIONS = 349,
    TCP_NO_NEW_CONN_BFLAG = 350,
    TCP_NO_NEW_CONN_RPLFLAG = 351,
    TCP_KEEPALIVE = 352,
    TCP_KEEPCOUNT = 353,
    TCP_KEEPIDLE = 354,
    TCP_KEEPINTERVAL = 355,
    TCP_MAX_MSG_TIME = 356,
    ADVERTISED_ADDRESS = 357,
    ADVERTISED_PORT = 358,
    DISABLE_CORE = 359,
    OPEN_FD_LIMIT = 360,
    MCAST_LOOPBACK = 361,
    MCAST_TTL = 362,
    TOS = 363,
    DISABLE_DNS_FAILOVER = 364,
    DISABLE_DNS_BLACKLIST = 365,
    DST_BLACKLIST = 366,
    DISABLE_STATELESS_FWD = 367,
    DB_VERSION_TABLE = 368,
    DB_DEFAULT_URL = 369,
    DB_MAX_ASYNC_CONNECTIONS = 370,
    DISABLE_503_TRANSLATION = 371,
    SYNC_TOKEN = 372,
    ASYNC_TOKEN = 373,
    LAUNCH_TOKEN = 374,
    AUTO_SCALING_PROFILE = 375,
    AUTO_SCALING_CYCLE = 376,
    TIMER_WORKERS = 377,
    EQUAL = 378,
    EQUAL_T = 379,
    GT = 380,
    LT = 381,
    GTE = 382,
    LTE = 383,
    DIFF = 384,
    MATCH = 385,
    NOTMATCH = 386,
    COLONEQ = 387,
    PLUSEQ = 388,
    MINUSEQ = 389,
    SLASHEQ = 390,
    MULTEQ = 391,
    MODULOEQ = 392,
    BANDEQ = 393,
    BOREQ = 394,
    BXOREQ = 395,
    OR = 396,
    AND = 397,
    BOR = 398,
    BAND = 399,
    BXOR = 400,
    BLSHIFT = 401,
    BRSHIFT = 402,
    PLUS = 403,
    MINUS = 404,
    SLASH = 405,
    MULT = 406,
    MODULO = 407,
    NOT = 408,
    BNOT = 409,
    RPAREN = 410,
    NUMBER = 411,
    ZERO = 412,
    ID = 413,
    STRING = 414,
    SCRIPTVAR = 415,
    IPV6ADDR = 416,
    IPV4ADDR = 417,
    IPNET = 418,
    COMMA = 419,
    SEMICOLON = 420,
    LPAREN = 421,
    LBRACE = 422,
    RBRACE = 423,
    LBRACK = 424,
    RBRACK = 425,
    AS = 426,
    USE_WORKERS = 427,
    USE_AUTO_SCALING_PROFILE = 428,
    MAX = 429,
    MIN = 430,
    DOT = 431,
    CR = 432,
    COLON = 433,
    ANY = 434,
    ANYCAST = 435,
    SCRIPTVARERR = 436,
    SCALE_UP_TO = 437,
    SCALE_DOWN_TO = 438,
    ON = 439,
    CYCLES = 440,
    CYCLES_WITHIN = 441,
    PERCENTAGE = 442
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 230 "cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct listen_param* listen_param;
	struct _pv_spec *specval;
	struct multi_str* multistr;

#line 458 "cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 475 "cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  204
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2322

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  188
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  85
/* YYNRULES -- Number of rules.  */
#define YYNRULES  468
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  898

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   442

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   479,   479,   482,   483,   484,   487,   488,   489,   489,
     490,   490,   491,   491,   492,   492,   493,   493,   494,   494,
     495,   495,   496,   496,   497,   497,   499,   502,   517,   526,
     541,   542,   545,   546,   560,   565,   575,   576,   579,   580,
     581,   585,   587,   589,   594,   600,   602,   606,   608,   610,
     612,   616,   619,   620,   623,   625,   627,   633,   636,   639,
     642,   645,   650,   651,   654,   655,   656,   656,   661,   661,
     668,   669,   671,   672,   675,   683,   694,   695,   696,   700,
     708,   716,   722,   730,   734,   735,   736,   737,   738,   742,
     744,   748,   749,   755,   756,   757,   758,   759,   760,   761,
     762,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   774,   775,   776,   777,   778,   779,   783,   784,
     787,   791,   792,   793,   801,   809,   817,   825,   833,   841,
     849,   857,   865,   873,   876,   877,   880,   881,   882,   883,
     884,   885,   886,   887,   888,   889,   890,   891,   901,   902,
     916,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,   931,   941,   951,   952,   955,
     956,   959,   963,   964,   967,   968,   971,   972,   976,   977,
     980,   981,   984,   985,   992,   993,  1000,  1002,  1005,  1006,
    1009,  1010,  1017,  1018,  1025,  1026,  1033,  1034,  1036,  1037,
    1041,  1042,  1045,  1046,  1048,  1049,  1051,  1053,  1055,  1056,
    1057,  1058,  1060,  1061,  1068,  1071,  1079,  1082,  1126,  1127,
    1132,  1134,  1136,  1137,  1143,  1145,  1159,  1161,  1164,  1165,
    1168,  1169,  1176,  1177,  1184,  1185,  1189,  1217,  1218,  1220,
    1221,  1224,  1225,  1228,  1229,  1239,  1241,  1243,  1244,  1246,
    1247,  1249,  1252,  1254,  1257,  1258,  1261,  1263,  1266,  1269,
    1273,  1274,  1280,  1286,  1290,  1291,  1294,  1310,  1326,  1327,
    1330,  1336,  1346,  1356,  1367,  1370,  1379,  1384,  1407,  1412,
    1420,  1436,  1439,  1445,  1448,  1456,  1462,  1465,  1471,  1474,
    1482,  1485,  1493,  1496,  1504,  1507,  1519,  1522,  1528,  1533,
    1534,  1535,  1536,  1537,  1538,  1541,  1542,  1545,  1546,  1547,
    1548,  1550,  1551,  1554,  1555,  1558,  1559,  1560,  1563,  1579,
    1584,  1585,  1586,  1588,  1593,  1596,  1599,  1602,  1605,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1624,
    1625,  1626,  1627,  1628,  1629,  1632,  1635,  1638,  1641,  1644,
    1647,  1650,  1653,  1656,  1659,  1662,  1665,  1678,  1691,  1713,
    1714,  1715,  1716,  1717,  1720,  1721,  1722,  1725,  1726,  1727,
    1730,  1731,  1732,  1736,  1737,  1738,  1741,  1742,  1743,  1744,
    1745,  1746,  1747,  1748,  1751,  1752,  1753,  1754,  1755,  1756,
    1757,  1758,  1759,  1762,  1770,  1780,  1788,  1798,  1806,  1824,
    1833,  1834,  1836,  1837,  1840,  1846,  1852,  1858,  1866,  1869,
    1872,  1877,  1887,  1894,  1901,  1911,  1916,  1923,  1933,  1938,
    1945,  1957,  1962,  1967,  1972,  1977,  1987,  1997,  2007,  2019,
    2037,  2068,  2072,  2078,  2081,  2082,  2083,  2084,  2085,  2087,
    2089,  2091,  2093,  2095,  2096,  2099,  2105,  2106,  2108,  2114,
    2115,  2117,  2121,  2140,  2141,  2143,  2166,  2202,  2204,  2207,
    2209,  2211,  2213,  2215,  2217,  2219,  2225,  2231,  2237
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DROP", "ASSERT", "EXIT", "RETURN",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE", "ROUTE_ONREPLY",
  "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL", "ROUTE_STARTUP",
  "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH", "CASE", "DEFAULT",
  "BREAK", "WHILE", "FOR", "IN", "NULLV", "XDBG", "XLOG", "XLOG_BUF_SIZE",
  "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL", "XLOG_LEVEL",
  "PV_PRINT_BUF_SIZE", "DEBUG_MODE", "ENABLE_ASSERTS", "ABORT_ON_ASSERT",
  "LOGLEVEL", "LOGSTDERROR", "LOGFACILITY", "LOGNAME", "AVP_ALIASES",
  "LISTEN", "SOCKET", "MEMGROUP", "ALIAS", "AUTO_ALIASES", "TAG", "DNS",
  "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR", "DNS_RETR_TIME",
  "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH", "MAX_WHILE_LOOPS",
  "UDP_WORKERS", "CHECK_VIA", "SHM_HASH_SPLIT_PERCENTAGE",
  "SHM_SECONDARY_HASH_SIZE", "MEM_WARMING_ENABLED",
  "MEM_WARMING_PATTERN_FILE", "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE",
  "RPM_MEM_SIZE", "MEMLOG", "MEMDUMP", "EXECMSGTHRESHOLD",
  "EXECDNSTHRESHOLD", "TCPTHRESHOLD", "EVENT_SHM_THRESHOLD",
  "EVENT_PKG_THRESHOLD", "QUERYBUFFERSIZE", "QUERYFLUSHTIME",
  "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER", "USER_AGENT_HEADER",
  "LOADMODULE", "MPATH", "MODPARAM", "MAXBUFFER", "CHROOT", "WDIR",
  "MHOMED", "POLL_METHOD", "TCP_ACCEPT_ALIASES", "TCP_WORKERS",
  "TCP_CONNECT_TIMEOUT", "TCP_CON_LIFETIME", "TCP_LISTEN_BACKLOG",
  "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS", "TCP_NO_NEW_CONN_BFLAG",
  "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE", "TCP_KEEPCOUNT",
  "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "MCAST_LOOPBACK", "MCAST_TTL", "TOS", "DISABLE_DNS_FAILOVER",
  "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST", "DISABLE_STATELESS_FWD",
  "DB_VERSION_TABLE", "DB_DEFAULT_URL", "DB_MAX_ASYNC_CONNECTIONS",
  "DISABLE_503_TRANSLATION", "SYNC_TOKEN", "ASYNC_TOKEN", "LAUNCH_TOKEN",
  "AUTO_SCALING_PROFILE", "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL",
  "EQUAL_T", "GT", "LT", "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH",
  "COLONEQ", "PLUSEQ", "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ",
  "BANDEQ", "BOREQ", "BXOREQ", "OR", "AND", "BOR", "BAND", "BXOR",
  "BLSHIFT", "BRSHIFT", "PLUS", "MINUS", "SLASH", "MULT", "MODULO", "NOT",
  "BNOT", "RPAREN", "NUMBER", "ZERO", "ID", "STRING", "SCRIPTVAR",
  "IPV6ADDR", "IPV4ADDR", "IPNET", "COMMA", "SEMICOLON", "LPAREN",
  "LBRACE", "RBRACE", "LBRACK", "RBRACK", "AS", "USE_WORKERS",
  "USE_AUTO_SCALING_PROFILE", "MAX", "MIN", "DOT", "CR", "COLON", "ANY",
  "ANYCAST", "SCRIPTVARERR", "SCALE_UP_TO", "SCALE_DOWN_TO", "ON",
  "CYCLES", "CYCLES_WITHIN", "PERCENTAGE", "$accept", "cfg", "statements",
  "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "listen_id", "host_sep", "host", "proto", "port", "snumber",
  "phostport", "panyhostport", "alias_def", "id_lst", "listen_id_def",
  "socket_def_param", "socket_def_params", "socket_def", "$@10", "$@11",
  "any_proto", "multi_string", "blst_elem", "blst_elem_list",
  "auto_scale_profile_def", "assign_stm", "module_stm", "ip", "ipv4",
  "ipv6addr", "ipv6", "ipnet", "folded_string", "route_name",
  "route_name_var", "route_stm", "failure_route_stm", "onreply_route_stm",
  "branch_route_stm", "error_route_stm", "local_route_stm",
  "startup_route_stm", "timer_route_stm", "event_route_stm", "exp",
  "equalop", "compop", "matchop", "intop", "strop", "script_var",
  "exp_elem", "exp_cond", "assignop", "assignexp", "assign_cmd", "exp_stm",
  "brk_stm", "stm", "actions", "brk_actions", "action", "brk_action",
  "brk_if_cmd", "if_cmd", "while_cmd", "foreach_cmd", "switch_cmd",
  "switch_stm", "case_stms", "case_stm", "default_stm", "func_param",
  "route_param", "async_func", "cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442
};
# endif

#define YYPACT_NINF -681

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-681)))

#define YYTABLE_NINF -409

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2145,   -98,   -61,   -59,   -18,   -10,    -2,    79,   272,   289,
     292,   358,   378,   386,   390,   397,   426,   439,   457,   461,
     469,    12,   123,   196,   344,   354,   399,   502,   506,   516,
     521,   522,   533,   553,   563,   586,   589,   611,   632,   636,
     639,   641,   646,   651,   670,   672,   682,   685,   686,   688,
      52,   689,    20,   693,   698,   699,   703,   711,   714,   715,
     717,   718,   722,   727,   728,   732,   742,   746,   747,   749,
     752,   753,   756,   757,   761,   769,   770,   775,   776,   405,
     474,   778,   781,   782,   785,   786,   789,   797,   799,   807,
    -681,   143,  2016,  -681,   232,   462,   139,   466,   451,   518,
     531,   535,   592,  -681,  -681,  -681,    53,    94,   135,   153,
     175,   305,   306,   309,   347,   317,    27,    90,   156,   157,
     458,   179,   324,   326,   327,  -681,   519,  -681,   562,  -681,
     568,  -681,   625,  -681,   777,  -681,   779,   328,   338,   341,
     346,   348,   349,    92,   355,   101,   362,    99,   302,   363,
     370,   373,   374,   387,   388,   389,   392,   402,   103,   115,
    -681,  -681,   116,  -681,   772,   403,     1,     4,   407,    86,
     408,   409,   419,   420,   421,   423,   425,    49,   140,   442,
     452,   454,   455,   456,    58,   459,   468,   475,   484,   485,
     241,  -681,   780,  -681,   790,   774,   791,   117,   118,   486,
     487,   141,   492,   794,  -681,   -98,  -681,    21,  -681,    36,
    -681,    66,  -681,    37,  -681,    46,  -681,    69,  -681,    70,
    -681,    41,  -681,    59,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,   796,   798,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,   933,  -681,   763,   -34,   494,  -681,  -681,  -681,
     787,  -681,   788,  -681,  -681,  -681,   803,   792,  -681,   -48,
     801,  -681,   609,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,   783,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,   793,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,   802,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,   805,  -681,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,   804,
    -681,  -681,  -681,   808,  -681,  1877,   595,  -681,   595,  -681,
    1877,   595,  -681,   595,  -681,  1877,  -681,  1877,  -681,  1877,
    -681,   595,  -681,   595,  -681,  -681,  -681,   800,   499,   499,
     119,   810,   705,  -681,   144,   809,   705,  -681,   815,   818,
     816,   811,   812,   827,   821,   822,   825,   529,    68,    74,
      87,   828,   829,   830,   831,   832,   833,   836,   837,    88,
    -681,  -681,  -681,   605,   839,   795,  -681,  -681,  -681,  -681,
    -681,    47,  -681,  -681,  -681,   820,   823,   824,   838,   840,
     853,   882,   920,   842,   844,   834,   841,   849,   705,   859,
     851,  -681,   499,  -681,  -681,  -681,   857,  -681,  -681,   845,
    -681,  -681,  -681,   856,  -681,   -26,   852,  -681,   862,  1424,
     867,   571,  -681,  -681,  -681,   174,  -681,   121,  -681,    14,
    1424,   -37,  1424,   -37,   876,   878,   883,   883,  -681,    44,
    1016,  1017,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    1606,  -681,  -681,  -681,  -681,  -681,  -681,   879,   881,  -681,
     891,   892,  -681,  -681,  -681,   889,   893,   -46,     5,  -681,
     884,  -681,  -681,  -681,  -681,  -681,    10,   573,   895,   244,
    -681,    23,   908,  -681,  1424,  1424,  1651,  1606,  -681,   -35,
    1784,  -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,   910,
     912,   914,   915,   907,   919,   911,   924,  -681,  -129,  -681,
     228,   926,   366,  1056,   -94,   -44,   509,   223,    91,   922,
     -52,   928,  -681,  -681,   658,  -681,  -681,   491,  -681,  -681,
    1606,  -681,  1606,  -681,  1001,  -681,  1328,  -681,  1877,  1877,
    1877,  1877,   927,  1877,  -681,  -681,  -681,  -681,  -681,    22,
    -681,  -681,   929,   941,   244,  -681,  -681,   934,  -681,   -26,
    -681,   947,  -681,   546,  -681,  1048,  1075,  1424,  1424,   943,
    -681,  -681,  -681,  -681,  -681,  -681,  -681,  -681,   500,   -51,
    -681,   347,   287,  -681,  -681,  -681,  -681,   944,  -681,   946,
    -681,  -681,   555,  1678,   940,  1441,   -37,  -681,  -681,  -681,
    -681,  -681,   949,  -681,  -681,   217,   595,  -681,   595,  -681,
    -681,  -681,  -681,  -681,   687,  -681,  1171,  1606,  1606,  1606,
    1606,  1606,  1606,  1606,  1606,  1606,  1606,  1086,  1115,  1144,
    1173,   942,  1339,  -681,  -681,  -681,  -681,   936,   734,  -681,
    1087,  -681,  -681,  -681,  -681,  -681,   958,  -681,  -681,  -681,
    -681,  -681,  -681,  -681,   962,   979,  -681,  -681,  -681,  -681,
     527,  1708,  1117,  -681,  1116,   972,   976,  -681,  1485,   977,
    -681,  -681,  -681,  -681,  -681,  -681,    73,   991,   258,   280,
     999,  -681,   541,   544,  1000,  -681,  -681,  -681,  -681,   767,
     767,   767,   767,   767,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  1877,  -681,   734,   992,  1002,  -681,  -681,
    -681,  -681,   601,  -681,  1368,  1678,   624,   989,   574,  -681,
    1424,  -681,  -681,   532,  -681,  -681,  -681,  -681,  1441,  -681,
    -681,  -681,  -681,  -681,  1003,  -681,  1397,   996,   -46,   428,
    -681,  -681,  -681,  -681,  -681,  -681,   983,   985,  -681,   987,
    -681,  -681,   552,  -681,  -681,  -681,  -681,  1015,  -681,   -46,
    1007,  1004,  1019,  1775,  1775,  1775,  1441,  -681,  1020,  1024,
    1029,  1005,   565,   598,   629,  1167,  1030,  1035,  1008,  1038,
    1441,  1040,  -681,  1043,  1012,  -681,  -681,  1051,  1044,  1182,
    1057,  1054,  1186,  1027,  1058,  -681,  1032,  -681
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      26,     0,     0,     4,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     6,     7,   258,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   101,     0,   103,     0,   105,
       0,   107,     0,   109,     0,   111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     260,   259,     0,   263,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   241,     0,   243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     5,     3,     0,     9,     0,
      11,     0,    13,     0,    15,     0,    17,     0,    19,     0,
      21,     0,    23,     0,    25,   208,   205,   209,   206,   210,
     207,   212,   211,   204,   203,    89,    88,    85,    84,    87,
      86,     0,     0,    38,    83,    91,    90,    93,    92,    95,
      94,   216,     0,    35,     0,    65,    64,   215,   214,   213,
       0,   220,    32,    28,   267,   266,     0,     0,    47,    29,
       0,    51,    52,   219,    27,   264,   268,   265,   222,   221,
      97,    96,    99,    98,   100,   102,   104,   106,   108,   110,
     113,   112,   118,   116,   122,   121,   124,   123,   126,   125,
     128,   127,   130,   129,   132,   131,   134,   133,   136,   135,
     138,   137,   140,   139,   142,   141,   144,   143,   146,   145,
     148,   147,   150,   149,   152,   151,   154,   153,   156,   155,
     198,   197,   200,   199,   202,   201,   239,   238,     0,   115,
     114,   159,   158,   157,   162,   161,   160,   164,   163,   167,
     165,   166,   169,   168,   172,   170,   174,   173,   176,   175,
     178,   177,   180,   179,   182,   181,   184,   183,   186,   185,
     188,   187,   192,   191,   194,   193,   196,   195,   190,   189,
     224,    32,   223,   226,   225,   228,   227,   230,   229,   232,
     231,   234,   233,   237,   235,   236,   240,   242,     0,   245,
     247,   246,   249,   248,   251,   250,   253,   252,   255,     0,
     254,   257,   256,   119,   281,     0,     0,   283,     0,   286,
       0,     0,   288,     0,   290,     0,   292,     0,   294,     0,
     296,     0,   298,     0,    39,    40,    44,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,    53,     0,     0,
       0,     0,     0,     0,   434,     0,   436,   443,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     318,   382,   319,     0,     0,     0,   371,   377,   378,   379,
     380,     0,   275,   274,   276,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    41,     0,     0,     0,
       0,    57,    62,    69,    67,   218,    72,   217,   269,    48,
      34,    33,   117,     0,   171,     0,     0,   120,     0,     0,
       0,     0,   440,   438,   446,     0,   449,     0,   453,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   458,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
       0,   381,   372,   279,   370,   383,   376,     0,     0,   284,
       0,     0,   289,   291,   293,     0,     0,     0,     0,    60,
      54,    59,    58,    61,    63,    73,     0,     0,     0,     0,
      77,     0,     0,   435,     0,     0,     0,     0,   322,     0,
     323,   304,   320,   361,   321,   360,   359,   437,   442,     0,
       0,     0,     0,     0,     0,     0,     0,   277,     0,   278,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   455,   410,   412,   415,   418,     0,   357,   358,
       0,   340,     0,   339,   341,   342,   356,   343,     0,     0,
       0,     0,     0,     0,    36,    37,    46,    43,    42,     0,
      50,    49,     0,     0,     0,    70,    71,     0,    78,     0,
     244,     0,   301,     0,   363,     0,     0,     0,     0,     0,
     305,   307,   308,   309,   310,   306,   311,   312,   313,   314,
     317,     0,     0,   441,   439,   447,   444,     0,   450,     0,
     454,   451,     0,     0,     0,     0,     0,   459,   272,   460,
     273,   461,     0,   462,   432,     0,     0,   468,     0,   457,
     413,   416,   419,   456,   414,   354,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    56,    55,   261,   262,     0,     0,    76,
       0,   302,   362,   303,   300,   299,     0,   327,   270,   271,
     328,   326,   325,   324,     0,     0,   423,   421,   422,   424,
       0,     0,   395,   367,     0,     0,     0,   391,     0,     0,
     397,   364,   386,   387,   388,   389,     0,     0,     0,     0,
       0,   429,     0,     0,     0,   411,   417,   420,   355,   350,
     349,   351,   352,   353,   344,   345,   347,   346,   348,   280,
     282,   285,   287,     0,   297,     0,     0,     0,   433,   445,
     448,   452,     0,   369,     0,     0,     0,     0,   401,   403,
       0,   384,   366,     0,   374,   390,   392,   385,     0,   463,
     464,   431,   430,   465,     0,   467,     0,     0,     0,     0,
     428,   425,   426,   427,   368,   396,     0,     0,   399,     0,
     402,   400,     0,   375,   365,   373,   398,     0,   295,     0,
       0,    82,     0,   407,   405,   409,     0,   466,     0,     0,
       0,    81,     0,     0,     0,   393,     0,     0,     0,     0,
       0,     0,    74,     0,     0,   394,    75,     0,     0,     0,
       0,     0,     0,     0,     0,    80,     0,    79
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -681,  -681,  -681,  1123,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -141,  -681,  -681,  -120,  -559,  -114,    32,
    -681,  -681,   956,  -681,  -681,  -376,  1111,  -681,  -681,   577,
     726,   576,  -681,  -681,  -681,  -681,  -293,  -681,   970,  -681,
    -680,  -504,  -382,  -681,  -681,  -681,  -681,  -681,  -681,  -681,
    -681,  -681,  -681,  -486,  -681,  -681,  -681,  -681,  -681,  -453,
    -681,  -503,  -681,   307,  -512,  -681,  -414,   422,  -417,   -73,
    -435,   -88,  -681,  -500,  -432,  -374,  -349,  -681,  -681,   424,
    -681,   534,  -681,   701,  -436
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   268,   445,   269,   254,   646,   633,   255,
     256,   272,   273,   571,   502,   503,   257,   439,   438,   657,
     507,   580,   581,   410,   103,   104,   274,   275,   276,   277,
     750,   615,   485,   608,   208,   210,   212,   214,   216,   218,
     220,   222,   224,   589,   678,   679,   680,   681,   682,   473,
     591,   635,   550,   636,   474,   594,   770,   762,   475,   823,
     476,   771,   772,   477,   478,   479,   480,   817,   818,   819,
     851,   627,   760,   619,   481
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     244,   270,   341,   487,   523,   344,   647,   593,   490,   648,
     491,   650,   492,   125,   -68,   606,   592,   651,   593,   595,
     593,   163,   414,   733,   658,   105,   691,   592,   247,   592,
     595,   617,   595,   311,   313,   692,   486,   417,   422,   488,
     554,   489,   430,   382,   610,   621,   612,   424,   555,   493,
     366,   494,   554,   160,   225,   554,   554,   554,   806,   380,
     432,   697,   106,   504,   107,   698,   590,   419,   600,   524,
     426,   428,   593,   593,   826,   526,   609,   590,   611,   590,
     613,   592,   592,   596,   595,   595,   626,   349,   528,   538,
     734,   249,   704,   302,   596,   227,   596,   634,   662,   663,
     310,   443,   306,   707,   332,   108,   667,   668,  -316,  -316,
     644,   699,   708,   109,   637,   700,   334,   336,   400,   402,
     505,   110,   604,   470,   127,   837,   574,   578,   444,   669,
    -316,   590,   590,   645,   634,   126,   229,   -68,   -68,   -68,
     579,   368,   408,   204,   472,   510,   -68,   607,   596,   596,
     211,   637,   270,   271,   231,   593,   593,   251,   258,   342,
     343,   644,   345,   346,   592,   592,   644,   595,   595,   665,
     482,   712,   483,   484,   470,   601,   233,   634,   644,   634,
     261,   744,   745,   769,   645,   248,   164,   659,   415,   645,
     416,   660,   241,   242,   637,   472,   637,   129,   779,   622,
     243,   645,   111,   623,   470,   418,   423,   367,   624,   226,
     431,   161,   556,   425,   590,   590,   381,   263,   780,   264,
     265,   727,   728,   729,   730,   472,   732,   266,   433,   753,
     554,   596,   596,   420,   525,   421,   427,   429,   827,   759,
     527,   207,   393,   777,   350,   351,   128,   241,   242,   250,
     228,   303,   626,   529,   539,   243,   769,   705,   763,   776,
     307,   787,   333,   773,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   335,   337,   401,   403,   506,   860,
     605,   637,   637,   637,   637,   637,   637,   637,   637,   637,
     637,   230,   554,   554,   554,   554,   496,   554,   369,   409,
     868,   509,   -30,   312,   271,   496,   235,   237,   593,   232,
     239,   769,   252,   252,   253,   253,   769,   592,   245,   130,
     595,   774,   241,   242,   783,   278,   784,   280,   282,   290,
     243,   234,   776,   602,   852,   252,   773,   262,   263,   292,
     264,   265,   294,   522,   814,   131,   775,   296,   266,   298,
     300,   769,   769,   769,   769,   133,   304,   570,   267,   843,
     769,   769,   769,   308,   314,   241,   242,   590,   769,   667,
     668,   316,   781,   243,   318,   320,   623,   470,   703,   554,
     763,   624,   700,   693,   596,   749,   836,   776,   322,   324,
     326,   773,   776,   328,   774,   112,   773,   394,   472,   395,
     135,   554,   253,   330,   339,   588,   191,   599,   347,   352,
     354,   603,   113,   829,   856,   114,   588,   698,   588,   775,
     356,   358,   360,   655,   362,   625,   364,   776,   776,   776,
     776,   773,   773,   773,   773,   830,   776,   776,   776,   700,
     773,   773,   773,   370,   776,   749,   752,   470,   773,   774,
     241,   242,   875,   372,   774,   374,   376,   378,   243,   656,
     383,   236,   238,   653,   215,   240,   885,   132,   472,   385,
     588,   588,   209,   246,   775,   193,   387,   134,   213,   775,
     279,   115,   281,   283,   291,   389,   391,   404,   406,   774,
     774,   774,   774,   411,   293,   241,   242,   295,   774,   774,
     774,   116,   297,   243,   299,   301,   774,   667,   668,   117,
     711,   305,   749,   118,   775,   775,   775,   775,   309,   315,
     119,   695,   136,   775,   775,   775,   317,   747,   192,   319,
     321,   775,   217,   853,   656,   454,   455,   456,   457,   458,
     459,   460,   -66,   323,   325,   327,   219,   497,   329,   120,
     765,   221,   462,   588,   588,   766,   463,   464,   331,   340,
     465,   466,   121,   348,   353,   355,   853,   751,   454,   455,
     456,   457,   458,   459,   460,   357,   359,   361,   758,   363,
     122,   365,   756,   765,   123,   462,  -406,  -406,   766,   463,
     464,   625,   124,   465,   466,   816,   849,   194,   371,   853,
     786,   454,   455,   456,   457,   458,   459,   460,   373,   223,
     375,   377,   379,   861,   862,   384,   765,   260,   462,  -404,
    -404,   766,   463,   464,   386,   137,   465,   466,   840,   138,
     853,   388,   454,   455,   456,   457,   458,   459,   460,   139,
     390,   392,   405,   407,   140,   141,   713,   765,   412,   462,
     467,   468,   766,   463,   464,   714,   142,   465,   466,  -315,
    -315,   264,   265,   748,   701,   -66,   -66,   -66,   698,   266,
     498,   499,   500,   702,   -66,   284,   143,   241,   242,   501,
     824,  -315,   811,   467,   468,   243,   144,   667,   668,   470,
     469,   812,   470,   667,   668,   521,   832,   767,   842,   833,
     854,   741,   847,   241,   242,   714,   588,   866,   834,   145,
     472,   243,   146,   472,   757,   470,   467,   468,   285,   241,
     242,   241,   242,   469,   286,   470,   598,   243,   540,   243,
     767,   470,   652,  -406,   147,   855,   472,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   472,   467,   468,   241,
     242,   482,   472,   483,   484,   148,   469,   243,   470,   149,
     841,   470,   150,   767,   151,   252,  -404,   262,   263,   152,
     264,   265,   241,   242,   153,   824,   824,   824,   266,   472,
     243,   287,   472,   846,   855,   855,   855,   469,   267,   470,
     872,   873,   874,   154,   767,   155,   552,  -408,   454,   455,
     456,   457,   458,   459,   460,   156,   241,   242,   157,   158,
     472,   159,   162,   461,   243,   462,   165,   710,   470,   463,
     464,   166,   167,   465,   466,   552,   168,   454,   455,   456,
     457,   458,   459,   460,   169,   241,   242,   170,   171,   472,
     172,   173,   461,   243,   462,   174,   785,   470,   463,   464,
     175,   176,   465,   466,   552,   177,   454,   455,   456,   457,
     458,   459,   460,   381,   263,   178,   264,   265,   472,   179,
     180,   461,   181,   462,   266,   182,   183,   463,   464,   184,
     185,   465,   466,   552,   186,   454,   455,   456,   457,   458,
     459,   460,   187,   188,   666,   264,   265,   748,   189,   190,
     461,   195,   462,   266,   196,   197,   463,   464,   198,   199,
     465,   466,   200,   467,   468,   722,   723,   724,   725,   726,
     201,   552,   202,   454,   455,   456,   457,   458,   459,   460,
     203,   338,   398,   288,   436,   289,   396,   715,   461,   716,
     462,   437,   467,   468,   463,   464,   397,   399,   465,   466,
     413,   495,   434,   469,   435,   470,   448,   449,   381,   263,
     471,   264,   265,   553,   264,   440,   -35,   511,   516,   266,
     442,   467,   468,   512,   514,   450,   472,   513,   515,   446,
     508,   453,   469,   451,   470,   517,   452,   518,   519,   471,
     557,   520,   559,   558,   530,   531,   532,   533,   534,   535,
     467,   468,   536,   537,   551,   472,   565,   569,   560,   573,
     561,   469,   567,   470,   566,   572,   506,   583,   471,   568,
     577,   562,   597,   576,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   472,   614,   582,   616,   467,   468,
     469,   618,   470,   628,   629,   642,   638,   471,   639,   552,
     563,   454,   455,   456,   457,   458,   459,   460,   640,   641,
     643,   654,   649,   472,   661,   683,   461,   684,   462,   685,
     686,   687,   463,   464,   688,   689,   465,   466,   469,   690,
     470,   694,   696,   709,   735,   471,   706,   552,   564,   454,
     455,   456,   457,   458,   459,   460,   736,   731,   738,   740,
     805,   472,   746,   754,   461,   755,   462,   764,   778,   803,
     463,   464,   807,   808,   465,   466,   552,   809,   454,   455,
     456,   457,   458,   459,   460,   670,   671,   672,   673,   674,
     675,   676,   677,   461,   810,   462,   815,   816,   820,   463,
     464,   821,   825,   465,   466,   552,   828,   454,   455,   456,
     457,   458,   459,   460,   831,   835,   838,   848,   839,   857,
     859,   863,   461,   864,   462,   865,   467,   468,   463,   464,
     867,   869,   465,   466,   552,   871,   454,   455,   456,   457,
     458,   459,   460,   877,   876,   878,   880,   870,   879,   881,
     882,   461,   883,   462,   884,   886,   888,   463,   464,   887,
     890,   465,   466,   889,   467,   468,   469,   891,   470,   892,
     893,   894,   895,   471,   896,   206,   742,   897,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   447,   472,
     259,   737,   575,   467,   468,   739,   441,   845,   620,   782,
       0,     0,   850,     0,   469,   743,   470,     0,     0,     0,
       0,   471,     0,     0,   799,     0,     0,     0,     0,     0,
       0,     0,   467,   468,     0,     0,     0,   472,     0,     0,
       0,     0,     0,   469,     0,   470,     0,     0,     0,     0,
     471,     0,     0,   800,     0,     0,     0,     0,     0,     0,
       0,   467,   468,     0,     0,     0,   472,     0,     0,     0,
       0,     0,   469,     0,   470,     0,     0,     0,     0,   471,
       0,     0,   801,     0,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,     0,   472,   788,     0,     0,     0,
       0,   469,     0,   470,     0,     0,     0,     0,   471,     0,
     552,   802,   454,   455,   456,   457,   458,   459,   460,     0,
       0,     0,     0,     0,   472,     0,     0,   461,     0,   462,
       0,     0,     0,   463,   464,     0,     0,   465,   466,   552,
       0,   454,   455,   456,   457,   458,   459,   460,     0,     0,
       0,     0,     0,     0,     0,     0,   461,     0,   462,     0,
       0,     0,   463,   464,     0,     0,   465,   466,   552,     0,
     454,   455,   456,   457,   458,   459,   460,     0,     0,     0,
       0,     0,     0,     0,     0,   461,     0,   462,     0,     0,
       0,   463,   464,     0,     0,   465,   466,   454,   455,   456,
     457,   458,   459,   460,     0,     0,     0,     0,     0,     0,
       0,     0,   461,     0,   454,   455,   456,   457,   458,   459,
     460,     0,   465,   466,     0,     0,     0,   467,   468,   765,
       0,   462,     0,     0,   766,   463,   464,     0,     0,   465,
     466,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,     0,     0,     0,     0,     0,   467,   468,   454,   455,
     456,   457,   458,   459,   460,     0,     0,   469,     0,   470,
       0,     0,     0,   765,   471,   462,     0,   804,   766,   463,
     464,     0,     0,   465,   466,   467,   468,     0,     0,     0,
     472,     0,     0,     0,     0,     0,   469,     0,   470,     0,
       0,     0,     0,   471,     0,     0,   844,     0,     0,     0,
       0,     0,   467,   468,     0,     0,     0,     0,     0,   472,
       0,     0,     0,     0,     0,   469,     0,   470,     0,   467,
     468,     0,   471,     0,     0,   858,     0,     0,     0,     0,
       0,     0,   241,   242,     0,     0,     0,   584,   472,     0,
     243,     0,   469,     0,   470,     0,     0,     0,     0,     0,
     585,   586,     0,   587,     0,     0,     0,     0,     0,   469,
       0,   470,     0,   467,   468,   472,   767,     0,   768,   454,
     455,   456,   457,   458,   459,   460,     0,     0,     0,     0,
       0,     0,   472,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   465,   466,     0,     0,     0,     0,
       0,     0,     0,   469,     0,   470,     0,     0,     0,     0,
     767,     0,     0,   822,   454,   455,   456,   457,   458,   459,
     460,     0,     0,     0,     0,     0,   472,     0,     0,   461,
       0,   462,     0,     0,     0,   463,   464,     0,     0,   465,
     466,   454,   455,   456,   457,   458,   459,   460,     0,     0,
       0,     0,     0,     0,     0,     0,   461,     0,   462,     0,
       0,     0,   463,   464,     0,     0,   465,   466,     0,     0,
       0,   454,   455,   456,   457,   458,   459,   460,     0,     0,
       0,     0,     0,     0,   467,   468,   461,     0,   462,     0,
       0,     0,   463,   464,     0,     0,   465,   466,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   241,   242,     0,     0,     0,     0,
     630,     0,   243,     0,   469,   631,   470,     0,     0,   467,
     468,     0,   632,     0,     0,     0,     0,     0,   454,   455,
     456,   457,   458,   459,   460,     0,     0,   472,     0,     0,
       0,     0,     0,   765,     0,   462,   467,   468,   766,   463,
     464,     0,     0,   465,   466,     0,     0,     0,     0,   469,
       0,   470,     0,     0,     0,     0,   471,     0,     0,   664,
       0,     0,     0,     0,     0,     0,   467,   468,     0,     0,
       0,     0,   472,     0,     0,     0,   469,     0,   470,     0,
       0,     0,     0,   471,     0,   761,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   472,
       0,     0,     0,     0,     0,     0,   469,     0,   470,     0,
       0,     0,     0,   471,     0,     0,   813,     0,     0,     0,
     454,   455,   456,   457,   458,   459,   460,     0,     0,   472,
       0,     0,     0,   467,   468,   461,     0,   462,     0,     0,
       0,   463,   464,     0,     0,   465,   466,   540,   670,   671,
     672,   673,   674,   675,   676,   677,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,     0,     0,     0,     0,
       0,     0,     0,   469,     0,   470,     0,     0,     0,     0,
     767,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   472,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   467,   468,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    -2,   205,     0,     0,
       0,     0,     0,     0,     0,    -8,   -10,   -12,   -14,   -16,
     -18,   -20,   -22,   -24,     0,   469,     0,   470,     0,     0,
       0,     0,   471,     0,     0,     0,     2,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,   472,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,     0,     0,     0,    87,    88,    89,     0,
       0,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     0,     0,    -8,   -10,   -12,   -14,   -16,   -18,
     -20,   -22,   -24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,     0,    14,    15,
      16,    17,    18,    90,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,     0,     0,     0,    87,    88,    89,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    90
};

static const yytype_int16 yycheck[] =
{
     114,   121,     1,   420,   457,     1,     1,   519,   425,   568,
     427,     1,   429,     1,    48,     1,   519,   576,   530,   519,
     532,     1,     1,     1,     1,   123,   155,   530,     1,   532,
     530,   535,   532,   147,   148,   164,   418,     1,     1,   421,
     475,   423,     1,   184,   530,     1,   532,     1,     1,   431,
       1,   433,   487,     1,     1,   490,   491,   492,   738,     1,
       1,   155,   123,   439,   123,   159,   519,     1,   521,     1,
       1,     1,   584,   585,     1,     1,   529,   530,   531,   532,
     533,   584,   585,   519,   584,   585,   539,     1,     1,     1,
     649,     1,     1,     1,   530,     1,   532,   550,   584,   585,
       1,   149,     1,   155,     1,   123,   141,   142,   159,   160,
     156,   155,   164,   123,   550,   159,     1,     1,     1,     1,
       1,   123,     1,   160,     1,   805,   502,   153,   176,   164,
     181,   584,   585,   179,   587,   123,     1,   171,   172,   173,
     166,     1,     1,     0,   181,     1,   180,   529,   584,   585,
      11,   587,   272,   121,     1,   667,   668,     1,     1,   158,
     159,   156,   158,   159,   667,   668,   156,   667,   668,   586,
     156,   624,   158,   159,   160,     1,     1,   630,   156,   632,
       1,   667,   668,   695,   179,   158,   166,   164,   167,   179,
     169,   168,   148,   149,   630,   181,   632,     1,   702,   155,
     156,   179,   123,   159,   160,   169,   169,   158,   164,   156,
     169,   159,   165,   167,   667,   668,   158,   159,     1,   161,
     162,   638,   639,   640,   641,   181,   643,   169,   169,   682,
     665,   667,   668,   167,   166,   169,   167,   167,   165,   692,
     166,     9,     1,   696,   158,   159,   123,   148,   149,   159,
     156,   159,   705,   166,   166,   156,   768,   166,   693,   695,
     159,   714,   159,   695,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   159,   159,   159,   159,   159,   838,
     159,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   156,   727,   728,   729,   730,   437,   732,   158,   158,
     859,   442,   158,     1,   272,   446,     1,     1,   820,   156,
       1,   823,   156,   156,   158,   158,   828,   820,     1,   123,
     820,   695,   148,   149,   706,     1,   708,     1,     1,     1,
     156,   156,   768,   159,   820,   156,   768,   158,   159,     1,
     161,   162,     1,   457,   761,     1,   695,     1,   169,     1,
       1,   863,   864,   865,   866,     1,     1,   498,   179,   812,
     872,   873,   874,     1,     1,   148,   149,   820,   880,   141,
     142,     1,   155,   156,     1,     1,   159,   160,   155,   814,
     815,   164,   159,   155,   820,   678,   803,   823,     1,     1,
       1,   823,   828,     1,   768,   123,   828,   156,   181,   158,
       1,   836,   158,     1,     1,   519,     1,   521,     1,     1,
       1,   525,   123,   155,   828,   123,   530,   159,   532,   768,
       1,     1,     1,   179,     1,   539,     1,   863,   864,   865,
     866,   863,   864,   865,   866,   155,   872,   873,   874,   159,
     872,   873,   874,     1,   880,   738,   159,   160,   880,   823,
     148,   149,   866,     1,   828,     1,     1,     1,   156,   579,
       1,   156,   156,   577,    13,   156,   880,   123,   181,     1,
     584,   585,    10,   156,   823,     1,     1,   123,    12,   828,
     156,   123,   156,   156,   156,     1,     1,     1,     1,   863,
     864,   865,   866,     1,   156,   148,   149,   156,   872,   873,
     874,   123,   156,   156,   156,   156,   880,   141,   142,   123,
     624,   156,   805,   123,   863,   864,   865,   866,   156,   156,
     123,   155,   123,   872,   873,   874,   156,    27,   123,   156,
     156,   880,    14,     1,   654,     3,     4,     5,     6,     7,
       8,     9,    48,   156,   156,   156,    15,    48,   156,   123,
      18,    16,    20,   667,   668,    23,    24,    25,   156,   156,
      28,    29,   123,   156,   156,   156,     1,   681,     3,     4,
       5,     6,     7,     8,     9,   156,   156,   156,   692,   156,
     123,   156,    27,    18,   123,    20,    21,    22,    23,    24,
      25,   705,   123,    28,    29,    21,    22,   123,   156,     1,
     714,     3,     4,     5,     6,     7,     8,     9,   156,    17,
     156,   156,   156,   185,   186,   156,    18,   159,    20,    21,
      22,    23,    24,    25,   156,   123,    28,    29,    27,   123,
       1,   156,     3,     4,     5,     6,     7,     8,     9,   123,
     156,   156,   156,   156,   123,   123,   155,    18,   156,    20,
     118,   119,    23,    24,    25,   164,   123,    28,    29,   159,
     160,   161,   162,   163,   155,   171,   172,   173,   159,   169,
     171,   172,   173,   164,   180,   156,   123,   148,   149,   180,
     768,   181,   155,   118,   119,   156,   123,   141,   142,   160,
     158,   164,   160,   141,   142,   166,   155,   165,   812,   155,
     168,   155,   816,   148,   149,   164,   820,   155,   164,   123,
     181,   156,   123,   181,   159,   160,   118,   119,   156,   148,
     149,   148,   149,   158,   156,   160,   155,   156,   123,   156,
     165,   160,   159,   168,   123,   823,   181,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   181,   118,   119,   148,
     149,   156,   181,   158,   159,   123,   158,   156,   160,   123,
     159,   160,   123,   165,   123,   156,   168,   158,   159,   123,
     161,   162,   148,   149,   123,   863,   864,   865,   169,   181,
     156,   156,   181,   159,   872,   873,   874,   158,   179,   160,
     863,   864,   865,   123,   165,   123,     1,   168,     3,     4,
       5,     6,     7,     8,     9,   123,   148,   149,   123,   123,
     181,   123,   123,    18,   156,    20,   123,   159,   160,    24,
      25,   123,   123,    28,    29,     1,   123,     3,     4,     5,
       6,     7,     8,     9,   123,   148,   149,   123,   123,   181,
     123,   123,    18,   156,    20,   123,   159,   160,    24,    25,
     123,   123,    28,    29,     1,   123,     3,     4,     5,     6,
       7,     8,     9,   158,   159,   123,   161,   162,   181,   123,
     123,    18,   123,    20,   169,   123,   123,    24,    25,   123,
     123,    28,    29,     1,   123,     3,     4,     5,     6,     7,
       8,     9,   123,   123,   587,   161,   162,   163,   123,   123,
      18,   123,    20,   169,   123,   123,    24,    25,   123,   123,
      28,    29,   123,   118,   119,   148,   149,   150,   151,   152,
     123,     1,   123,     3,     4,     5,     6,     7,     8,     9,
     123,   159,   158,   156,     1,   156,   156,   630,    18,   632,
      20,   178,   118,   119,    24,    25,   156,   156,    28,    29,
     156,   151,   156,   158,   156,   160,   173,   164,   158,   159,
     165,   161,   162,   168,   161,   178,   178,   158,   156,   169,
     178,   118,   119,   158,   158,   173,   181,   159,   167,   178,
     170,   173,   158,   178,   160,   158,   182,   166,   166,   165,
     170,   166,   168,   170,   166,   166,   166,   166,   166,   166,
     118,   119,   166,   166,   165,   181,   164,   158,   170,   158,
     170,   158,   178,   160,   170,   156,   159,   155,   165,   178,
     164,   168,   155,   178,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   181,   159,   184,   159,   118,   119,
     158,   158,   160,    27,    27,   156,   167,   165,   167,     1,
     168,     3,     4,     5,     6,     7,     8,     9,   167,   167,
     167,   166,   178,   181,   156,   155,    18,   155,    20,   155,
     155,   164,    24,    25,   155,   164,    28,    29,   158,   155,
     160,   155,    26,   155,   155,   165,   164,     1,   168,     3,
       4,     5,     6,     7,     8,     9,   155,   170,   164,   152,
     164,   181,   159,   159,    18,   159,    20,   167,   159,   167,
      24,    25,    25,   155,    28,    29,     1,   155,     3,     4,
       5,     6,     7,     8,     9,   124,   125,   126,   127,   128,
     129,   130,   131,    18,   155,    20,    19,    21,   166,    24,
      25,   165,   165,    28,    29,     1,   155,     3,     4,     5,
       6,     7,     8,     9,   155,   155,   164,   168,   156,   156,
     164,   178,    18,   178,    20,   178,   118,   119,    24,    25,
     155,   164,    28,    29,     1,   156,     3,     4,     5,     6,
       7,     8,     9,   159,   164,   156,    19,   183,   183,   159,
     155,    18,   184,    20,   156,   155,   184,    24,    25,   156,
     156,    28,    29,   152,   118,   119,   158,    25,   160,   152,
     156,    25,   185,   165,   156,    92,   168,   185,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   272,   181,
     119,   654,   506,   118,   119,   659,   266,   815,   537,   705,
      -1,    -1,   818,    -1,   158,   170,   160,    -1,    -1,    -1,
      -1,   165,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   118,   119,    -1,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,   158,    -1,   160,    -1,    -1,    -1,    -1,
     165,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   118,   119,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,   158,    -1,   160,    -1,    -1,    -1,    -1,   165,
      -1,    -1,   168,    -1,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,    -1,   181,   155,    -1,    -1,    -1,
      -1,   158,    -1,   160,    -1,    -1,    -1,    -1,   165,    -1,
       1,   168,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    18,    -1,    20,
      -1,    -1,    -1,    24,    25,    -1,    -1,    28,    29,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    -1,    20,    -1,
      -1,    -1,    24,    25,    -1,    -1,    28,    29,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    28,    29,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    -1,     3,     4,     5,     6,     7,     8,
       9,    -1,    28,    29,    -1,    -1,    -1,   118,   119,    18,
      -1,    20,    -1,    -1,    23,    24,    25,    -1,    -1,    28,
      29,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,    -1,    -1,    -1,    -1,    -1,   118,   119,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,   158,    -1,   160,
      -1,    -1,    -1,    18,   165,    20,    -1,   168,    23,    24,
      25,    -1,    -1,    28,    29,   118,   119,    -1,    -1,    -1,
     181,    -1,    -1,    -1,    -1,    -1,   158,    -1,   160,    -1,
      -1,    -1,    -1,   165,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    -1,   118,   119,    -1,    -1,    -1,    -1,    -1,   181,
      -1,    -1,    -1,    -1,    -1,   158,    -1,   160,    -1,   118,
     119,    -1,   165,    -1,    -1,   168,    -1,    -1,    -1,    -1,
      -1,    -1,   148,   149,    -1,    -1,    -1,   153,   181,    -1,
     156,    -1,   158,    -1,   160,    -1,    -1,    -1,    -1,    -1,
     166,   167,    -1,   169,    -1,    -1,    -1,    -1,    -1,   158,
      -1,   160,    -1,   118,   119,   181,   165,    -1,   167,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   158,    -1,   160,    -1,    -1,    -1,    -1,
     165,    -1,    -1,   168,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,    18,
      -1,    20,    -1,    -1,    -1,    24,    25,    -1,    -1,    28,
      29,     3,     4,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,    -1,    20,    -1,
      -1,    -1,    24,    25,    -1,    -1,    28,    29,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    -1,   118,   119,    18,    -1,    20,    -1,
      -1,    -1,    24,    25,    -1,    -1,    28,    29,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   148,   149,    -1,    -1,    -1,    -1,
     154,    -1,   156,    -1,   158,   159,   160,    -1,    -1,   118,
     119,    -1,   166,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,   181,    -1,    -1,
      -1,    -1,    -1,    18,    -1,    20,   118,   119,    23,    24,
      25,    -1,    -1,    28,    29,    -1,    -1,    -1,    -1,   158,
      -1,   160,    -1,    -1,    -1,    -1,   165,    -1,    -1,   168,
      -1,    -1,    -1,    -1,    -1,    -1,   118,   119,    -1,    -1,
      -1,    -1,   181,    -1,    -1,    -1,   158,    -1,   160,    -1,
      -1,    -1,    -1,   165,    -1,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,
      -1,    -1,    -1,    -1,    -1,    -1,   158,    -1,   160,    -1,
      -1,    -1,    -1,   165,    -1,    -1,   168,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,   181,
      -1,    -1,    -1,   118,   119,    18,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    28,    29,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   158,    -1,   160,    -1,    -1,    -1,    -1,
     165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   118,   119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    -1,   158,    -1,   160,    -1,    -1,
      -1,    -1,   165,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,   181,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,    -1,    -1,    -1,   120,   121,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,   177,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,    -1,    -1,    -1,   120,   121,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   177
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    43,    44,    45,    46,    47,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   120,   121,   122,
     177,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   222,   223,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,     1,   123,     1,   123,     1,
     123,     1,   123,     1,   123,     1,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
       1,   159,   123,     1,   166,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,     1,   123,     1,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,     0,     1,   191,     9,   232,    10,
     233,    11,   234,    12,   235,    13,   236,    14,   237,    15,
     238,    16,   239,    17,   240,     1,   156,     1,   156,     1,
     156,     1,   156,     1,   156,     1,   156,     1,   156,     1,
     156,   148,   149,   156,   206,     1,   156,     1,   158,     1,
     159,     1,   156,   158,   204,   207,   208,   214,     1,   214,
     159,     1,   158,   159,   161,   162,   169,   179,   201,   203,
     204,   207,   209,   210,   224,   225,   226,   227,     1,   156,
       1,   156,     1,   156,   156,   156,   156,   156,   156,   156,
       1,   156,     1,   156,     1,   156,     1,   156,     1,   156,
       1,   156,     1,   159,     1,   156,     1,   159,     1,   156,
       1,   206,     1,   206,     1,   156,     1,   156,     1,   156,
       1,   156,     1,   156,     1,   156,     1,   156,     1,   156,
       1,   156,     1,   159,     1,   159,     1,   159,   159,     1,
     156,     1,   158,   159,     1,   158,   159,     1,   156,     1,
     158,   159,     1,   156,     1,   156,     1,   156,     1,   156,
       1,   156,     1,   156,     1,   156,     1,   158,     1,   158,
       1,   156,     1,   156,     1,   156,     1,   156,     1,   156,
       1,   158,   201,     1,   156,     1,   156,     1,   156,     1,
     156,     1,   156,     1,   156,   158,   156,   156,   158,   156,
       1,   159,     1,   159,     1,   156,     1,   156,     1,   158,
     221,     1,   156,   156,     1,   167,   169,     1,   169,     1,
     167,   169,     1,   169,     1,   167,     1,   167,     1,   167,
       1,   169,     1,   169,   156,   156,     1,   178,   216,   215,
     178,   226,   178,   149,   176,   202,   178,   210,   173,   164,
     173,   178,   182,   173,     3,     4,     5,     6,     7,     8,
       9,    18,    20,    24,    25,    28,    29,   118,   119,   158,
     160,   165,   181,   247,   252,   256,   258,   261,   262,   263,
     264,   272,   156,   158,   159,   230,   230,   256,   230,   230,
     256,   256,   256,   230,   230,   151,   201,    48,   171,   172,
     173,   180,   212,   213,   213,     1,   159,   218,   170,   201,
       1,   158,   158,   159,   158,   167,   156,   158,   166,   166,
     166,   166,   206,   247,     1,   166,     1,   166,     1,   166,
     166,   166,   166,   166,   166,   166,   166,   166,     1,   166,
     123,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     250,   165,     1,   168,   258,     1,   165,   170,   170,   168,
     170,   170,   168,   168,   168,   164,   170,   178,   178,   158,
     201,   211,   156,   158,   213,   218,   178,   164,   153,   166,
     219,   220,   184,   155,   153,   166,   167,   169,   206,   241,
     247,   248,   249,   252,   253,   261,   272,   155,   155,   206,
     247,     1,   159,   206,     1,   159,     1,   230,   231,   247,
     241,   247,   241,   247,   159,   229,   159,   229,   158,   271,
     271,     1,   155,   159,   164,   206,   247,   269,    27,    27,
     154,   159,   166,   206,   247,   249,   251,   272,   167,   167,
     167,   167,   156,   167,   156,   179,   205,     1,   205,   178,
       1,   205,   159,   206,   166,   179,   204,   217,     1,   164,
     168,   156,   241,   241,   168,   256,   251,   141,   142,   164,
     124,   125,   126,   127,   128,   129,   130,   131,   242,   243,
     244,   245,   246,   155,   155,   155,   155,   164,   155,   164,
     155,   155,   164,   155,   155,   155,    26,   155,   159,   155,
     159,   155,   164,   155,     1,   166,   164,   155,   164,   155,
     159,   206,   247,   155,   164,   251,   251,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   256,   256,   256,
     256,   170,   256,     1,   205,   155,   155,   217,   164,   219,
     152,   155,   168,   170,   241,   241,   159,    27,   163,   224,
     228,   206,   159,   247,   159,   159,    27,   159,   206,   247,
     270,   167,   255,   258,   167,    18,    23,   165,   167,   252,
     254,   259,   260,   262,   263,   264,   272,   247,   159,   229,
       1,   155,   269,   230,   230,   159,   206,   247,   155,   251,
     251,   251,   251,   251,   251,   251,   251,   251,   251,   168,
     168,   168,   168,   167,   168,   164,   228,    25,   155,   155,
     155,   155,   164,   168,   256,    19,    21,   265,   266,   267,
     166,   165,   168,   257,   259,   165,     1,   165,   155,   155,
     155,   155,   155,   155,   164,   155,   256,   228,   164,   156,
      27,   159,   206,   247,   168,   255,   159,   206,   168,    22,
     267,   268,   241,     1,   168,   259,   254,   156,   168,   164,
     205,   185,   186,   178,   178,   178,   155,   155,   205,   164,
     183,   156,   257,   257,   257,   254,   164,   159,   156,   183,
      19,   159,   155,   184,   156,   254,   155,   156,   184,   152,
     156,    25,   152,   156,    25,   185,   156,   185
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   188,   189,   190,   190,   190,   191,   191,   192,   191,
     193,   191,   194,   191,   195,   191,   196,   191,   197,   191,
     198,   191,   199,   191,   200,   191,   191,   201,   201,   201,
     202,   202,   203,   203,   203,   204,   205,   205,   206,   206,
     206,   207,   207,   207,   207,   208,   208,   209,   209,   209,
     209,   209,   210,   210,   211,   211,   211,   212,   212,   212,
     212,   212,   213,   213,   214,   214,   215,   214,   216,   214,
     217,   217,   218,   218,   219,   219,   220,   220,   220,   221,
     221,   221,   221,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   223,
     223,   223,   223,   223,   224,   224,   225,   226,   227,   227,
     228,   228,   229,   229,   230,   230,   230,   231,   231,   232,
     232,   232,   233,   233,   234,   234,   234,   235,   235,   236,
     236,   237,   237,   238,   238,   239,   239,   240,   240,   241,
     241,   241,   241,   241,   241,   242,   242,   243,   243,   243,
     243,   244,   244,   245,   245,   246,   246,   246,   247,   247,
     248,   248,   248,   248,   249,   249,   249,   249,   249,   250,
     250,   250,   250,   250,   250,   250,   250,   250,   250,   251,
     251,   251,   251,   251,   251,   251,   251,   251,   251,   251,
     251,   251,   251,   251,   251,   251,   252,   252,   252,   253,
     253,   253,   253,   253,   254,   254,   254,   255,   255,   255,
     256,   256,   256,   257,   257,   257,   258,   258,   258,   258,
     258,   258,   258,   258,   259,   259,   259,   259,   259,   259,
     259,   259,   259,   260,   260,   261,   261,   262,   263,   264,
     265,   265,   266,   266,   267,   267,   267,   267,   268,   268,
     269,   269,   269,   269,   269,   269,   269,   269,   269,   269,
     269,   270,   270,   270,   270,   270,   270,   270,   270,   271,
     271,   271,   271,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     2,     2,
       2,     2,     1,     2,     1,     1,     0,     3,     0,     3,
       1,     1,     1,     2,     9,    10,     3,     1,     2,    18,
      17,    10,     9,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     3,     3,     3,     3,     5,     3,     3,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     5,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     2,     7,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       2,     8,     8,     2,     1,     1,     1,     1,     1,     3,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     4,
       7,     2,     7,     2,     4,     7,     2,     7,     2,     4,
       2,     4,     2,     4,     2,     9,     2,     7,     2,     3,
       3,     2,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     3,     1,
       1,     1,     3,     2,     1,     3,     2,     1,     3,     2,
       2,     1,     2,     2,     1,     2,     2,     1,     1,     1,
       1,     2,     1,     2,     2,     2,     1,     1,     1,     1,
       2,     1,     2,     5,     7,     5,     7,     5,     7,     7,
       2,     1,     2,     1,     4,     3,     4,     3,     3,     2,
       1,     3,     1,     2,     2,     1,     2,     3,     1,     2,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       4,     4,     2,     6,     1,     3,     1,     3,     2,     4,
       2,     4,     3,     1,     4,     6,     2,     4,     6,     2,
       4,     4,     6,     2,     4,     3,     4,     4,     2,     4,
       4,     4,     4,     6,     6,     6,     8,     6,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 482 "cfg.y" /* yacc.c:1646  */
    {}
#line 2516 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 483 "cfg.y" /* yacc.c:1646  */
    {}
#line 2522 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 484 "cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 2528 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 489 "cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 2534 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 490 "cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 2540 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 491 "cfg.y" /* yacc.c:1646  */
    {rt=ONREPLY_ROUTE;}
#line 2546 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 492 "cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 2552 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 493 "cfg.y" /* yacc.c:1646  */
    {rt=ERROR_ROUTE;}
#line 2558 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 494 "cfg.y" /* yacc.c:1646  */
    {rt=LOCAL_ROUTE;}
#line 2564 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 495 "cfg.y" /* yacc.c:1646  */
    {rt=STARTUP_ROUTE;}
#line 2570 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 496 "cfg.y" /* yacc.c:1646  */
    {rt=TIMER_ROUTE;}
#line 2576 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 497 "cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 2582 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 502 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2602 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 517 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2616 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 526 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2634 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 541 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)=".";}
#line 2640 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 542 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)="-"; }
#line 2646 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 545 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 2652 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 546 "cfg.y" /* yacc.c:1646  */
    { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2671 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 560 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2679 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 565 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2692 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 575 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2698 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 576 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 2704 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 579 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2710 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 580 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2716 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 581 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 2722 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 585 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2729 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 587 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2736 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 589 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2746 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 594 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2755 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 600 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2762 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 602 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 2769 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 606 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2776 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 608 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2783 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 610 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2790 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 612 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2799 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 619 "cfg.y" /* yacc.c:1646  */
    { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2805 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 620 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2811 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 623 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2818 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 625 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2825 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 627 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2834 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 633 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2842 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 636 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2850 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 639 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2858 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 642 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2866 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 645 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2874 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 654 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2880 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 655 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2886 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 656 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2894 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 658 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2902 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 661 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2910 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 663 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2918 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 668 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_NONE; }
#line 2924 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 669 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2930 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 671 "cfg.y" /* yacc.c:1646  */
    {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 2936 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 672 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 2942 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 675 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2955 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 683 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2969 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 694 "cfg.y" /* yacc.c:1646  */
    {}
#line 2975 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 695 "cfg.y" /* yacc.c:1646  */
    {}
#line 2981 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 696 "cfg.y" /* yacc.c:1646  */
    { yyerror("bad black list element");}
#line 2987 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 703 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 2997 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 711 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3007 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 717 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3017 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 723 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3027 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 730 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3036 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 734 "cfg.y" /* yacc.c:1646  */
    { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 3042 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 735 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3048 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 736 "cfg.y" /* yacc.c:1646  */
    { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 3054 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 737 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3060 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 738 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) { *log_level = L_DBG;log_stderr=1;}
			}
#line 3069 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 743 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected for debug_mode"); }
#line 3075 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 747 "cfg.y" /* yacc.c:1646  */
    { IFOR(); if (!config_check && !debug_mode) log_stderr=(yyvsp[0].intval); }
#line 3081 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 748 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3087 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 749 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3098 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 755 "cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 3104 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 756 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_name=(yyvsp[0].strval); }
#line 3110 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 757 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3116 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 758 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3122 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 759 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3128 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 760 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3134 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 761 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3140 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 762 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3146 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 763 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3152 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 764 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3158 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 765 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3164 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 766 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3170 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 767 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3176 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 768 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3182 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 769 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3188 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 770 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3194 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 771 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3200 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 772 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3206 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 773 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3212 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 774 "cfg.y" /* yacc.c:1646  */
    { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3218 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 775 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3224 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 776 "cfg.y" /* yacc.c:1646  */
    { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3230 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 777 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3236 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 778 "cfg.y" /* yacc.c:1646  */
    { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3242 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 779 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3251 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 783 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3257 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 784 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3265 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 787 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3274 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 791 "cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 3280 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 792 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3286 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 793 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3299 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 801 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3312 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 809 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3325 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 817 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3338 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 825 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3351 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 833 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3364 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 841 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3377 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 849 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3390 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 857 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3403 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 865 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3416 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 873 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3424 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 876 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3430 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 877 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3438 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 880 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3444 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 881 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3450 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 882 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3456 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 883 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memdump=(yyvsp[0].intval); }
#line 3462 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 884 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3468 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 885 "cfg.y" /* yacc.c:1646  */
    {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 3474 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 886 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3480 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 887 "cfg.y" /* yacc.c:1646  */
    { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 3486 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 888 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3492 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 889 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 3498 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 890 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3504 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 891 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 3519 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 901 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3525 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 902 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 3544 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 916 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3550 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 917 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 3556 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 918 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3562 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 919 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 3568 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 920 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3574 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 921 "cfg.y" /* yacc.c:1646  */
    { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 3580 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 922 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3586 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 923 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3592 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 924 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3598 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 925 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3604 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 926 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3610 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 927 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3616 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 928 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3622 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 929 "cfg.y" /* yacc.c:1646  */
    { IFOR(); mhomed=(yyvsp[0].intval); }
#line 3628 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 930 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3634 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 931 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 3649 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 941 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 3664 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 951 "cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 3670 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 952 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 3678 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 955 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3684 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 956 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 3692 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 959 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3701 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 963 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3707 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 964 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 3715 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 967 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3721 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 968 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 3729 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 971 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3735 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 972 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				warn("tcp_listen_backlog is deprecated, use tcp_socket_backlog");
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3744 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 976 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3750 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 977 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3758 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 980 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3764 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 981 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 3772 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 984 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3778 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 985 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 3790 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 992 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 3796 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 993 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 3808 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1000 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 3814 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1002 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_keepalive=(yyvsp[0].intval);
		}
#line 3822 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1005 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3828 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1006 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 3836 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1009 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3842 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1010 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 3854 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1017 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3860 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1018 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 3872 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1025 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3878 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1026 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 3890 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1033 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3896 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1034 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 3903 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1036 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3909 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1037 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_header.s=(yyvsp[0].strval);
							server_header.len=strlen((yyvsp[0].strval));
							}
#line 3918 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1041 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3924 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1042 "cfg.y" /* yacc.c:1646  */
    { user_agent_header.s=(yyvsp[0].strval);
									user_agent_header.len=strlen((yyvsp[0].strval));
									}
#line 3932 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1045 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3938 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1046 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 3945 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1048 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3951 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1049 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 3958 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1051 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 3965 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1053 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 3972 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1055 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3978 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1056 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3984 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1057 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3990 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1058 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 3997 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1060 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4003 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1061 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listening socket\n");
								break;
							}
						}
#line 4015 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1068 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4023 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1071 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 4036 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1079 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4044 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1082 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;	

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4093 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1126 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid or no module specified"); }
#line 4099 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1127 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4109 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1132 "cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4116 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1134 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4123 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1136 "cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 4129 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1137 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address.s=(yyvsp[0].strval);
									default_global_address.len=strlen((yyvsp[0].strval));
								}
								}
#line 4140 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1143 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4147 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1145 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port.len)
									default_global_port.s =
									pkg_realloc(default_global_port.s, i_tmp);
								if (!default_global_port.s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port.len = i_tmp;
									memcpy(default_global_port.s, tmp,
											default_global_port.len);
								}
								}
#line 4166 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1159 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4173 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1161 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4181 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1164 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4187 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1165 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4195 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1168 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4201 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1169 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4213 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1176 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4219 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1177 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4231 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1184 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected as tos"); }
#line 4237 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1185 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4246 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1189 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4279 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1217 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4285 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1218 "cfg.y" /* yacc.c:1646  */
    {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 4292 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1220 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4298 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1221 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4306 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1224 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4312 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1225 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4320 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1228 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4326 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1229 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				s_tmp.s = (yyvsp[-4].strval);
				s_tmp.len = strlen((yyvsp[-4].strval));
				if (create_bl_head( BL_CORE_ID, BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4341 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1239 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4348 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1241 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4355 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1243 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4361 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1244 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4368 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1246 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4374 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1247 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4381 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1249 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4389 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1252 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4396 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1254 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4404 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1257 "cfg.y" /* yacc.c:1646  */
    {}
#line 4410 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1258 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("bad auto-scaling profile definition");
				}
#line 4418 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1261 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 4425 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1263 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4433 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1266 "cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 4439 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1269 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4448 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1273 "cfg.y" /* yacc.c:1646  */
    { yyerror("string expected");  }
#line 4454 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1274 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4465 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1280 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4476 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1286 "cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 4482 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1290 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4488 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1291 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4494 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1294 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 4513 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1310 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 4532 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1326 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4538 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1327 "cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 4544 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1330 "cfg.y" /* yacc.c:1646  */
    {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 4555 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1336 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 4564 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1346 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4579 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1356 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4594 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1367 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 4602 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1370 "cfg.y" /* yacc.c:1646  */
    {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 4616 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1379 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 4624 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1384 "cfg.y" /* yacc.c:1646  */
    {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 4652 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1407 "cfg.y" /* yacc.c:1646  */
    {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 4661 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1412 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 4674 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1420 "cfg.y" /* yacc.c:1646  */
    {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 4695 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1436 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 4701 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1439 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 4712 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1445 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 4718 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1448 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 4731 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1456 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 4742 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1462 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 4748 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1465 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 4759 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1471 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 4765 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1474 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 4778 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1482 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid error_route statement"); }
#line 4784 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1485 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 4797 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1493 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid local_route statement"); }
#line 4803 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1496 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 4816 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1504 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid startup_route statement"); }
#line 4822 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1507 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = 0;
						while(sroutes->timer[i_tmp].a!=0 && i_tmp<TIMER_RT_NO){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 4839 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1519 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid timer_route statement"); }
#line 4845 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1522 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 4856 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1528 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 4862 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1533 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4868 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1534 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 4874 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1535 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 4880 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1536 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 4886 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1537 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[-1].expr); }
#line 4892 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1538 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[0].expr); }
#line 4898 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1541 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 4904 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1542 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 4910 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1545 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 4916 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1546 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 4922 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1547 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 4928 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1548 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 4934 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1550 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 4940 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1551 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=NOTMATCH_OP; }
#line 4946 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1554 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4952 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1555 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4958 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1558 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4964 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1559 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4970 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1560 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 4976 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1563 "cfg.y" /* yacc.c:1646  */
    {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 4997 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1579 "cfg.y" /* yacc.c:1646  */
    {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5005 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1584 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=(yyvsp[0].expr); }
#line 5011 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1585 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5017 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1586 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5024 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1588 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5032 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1593 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5040 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1596 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5048 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1599 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5056 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1602 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5064 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1605 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5072 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1611 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = EQ_T; }
#line 5078 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1612 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = COLONEQ_T; }
#line 5084 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1613 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = PLUSEQ_T; }
#line 5090 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1614 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MINUSEQ_T;}
#line 5096 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1615 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = DIVEQ_T; }
#line 5102 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1616 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MULTEQ_T; }
#line 5108 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1617 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MODULOEQ_T; }
#line 5114 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1618 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BANDEQ_T; }
#line 5120 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1619 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BOREQ_T; }
#line 5126 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1620 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BXOREQ_T; }
#line 5132 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1624 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5138 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1625 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5144 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1626 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5150 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1627 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)= (yyvsp[0].expr); }
#line 5156 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1628 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5162 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1629 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5170 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1632 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5178 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1635 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5186 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1638 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5194 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1641 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5202 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1644 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5210 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1647 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5218 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1650 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5226 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1653 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5234 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1656 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5242 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1659 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5250 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1662 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 5256 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1665 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5274 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1678 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5292 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1691 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			/* not all can get NULL with := */
			switch((yyvsp[-2].specval)->type) {
				case PVT_AVP:
				break;
				default:
					yyerror("invalid left operand in NULL assignment");
			}
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5317 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1713 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5323 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1714 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5329 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1715 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5335 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1716 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5341 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1717 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5347 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1720 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5353 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1721 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5359 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1722 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5365 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1725 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5371 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1726 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5377 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1727 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5383 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1730 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5389 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1731 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5395 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1732 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5401 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1736 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5407 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1737 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5413 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1738 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5419 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1741 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5425 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1742 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5431 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1743 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5437 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1744 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5443 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1745 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5449 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1746 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5455 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1747 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 5461 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1748 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5467 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1751 "cfg.y" /* yacc.c:1646  */
    { mk_action0((yyval.action), BREAK_T);}
#line 5473 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1752 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5479 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1753 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5485 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1754 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5491 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1755 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5497 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1756 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5503 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1757 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5509 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1758 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 5515 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1759 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5521 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1762 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5534 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1770 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5547 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1780 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5560 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1788 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5573 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1798 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 5584 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1806 "cfg.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 5605 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1824 "cfg.y" /* yacc.c:1646  */
    {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 5617 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1833 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5623 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1834 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5629 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1836 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5635 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1837 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5641 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1840 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 5652 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1846 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 5663 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1852 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 5674 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1858 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 5685 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1866 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 5693 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1869 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 5699 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1872 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 5709 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1877 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5724 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1887 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 5736 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1894 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 5748 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1901 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 5763 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1911 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 5773 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1916 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 5785 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1923 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5800 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1933 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 5810 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1938 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 5822 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1945 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5837 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1957 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 5847 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1962 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 5857 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1967 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 5867 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1972 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 5877 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1977 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5892 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1987 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5907 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1997 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5922 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2007 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5937 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2019 "cfg.y" /* yacc.c:1646  */
    {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-2].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(cmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 5960 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2037 "cfg.y" /* yacc.c:1646  */
    {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-3].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 5996 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2068 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6005 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2072 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6014 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2078 "cfg.y" /* yacc.c:1646  */
    {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6022 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2081 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6028 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2082 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6034 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2083 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6040 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2084 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6046 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2086 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 6052 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2088 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 6058 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2090 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 6064 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2092 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 6070 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2094 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6076 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2095 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6082 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2096 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6090 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2099 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6101 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2105 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6107 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2106 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6114 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2108 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6125 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2114 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6131 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2115 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6138 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2117 "cfg.y" /* yacc.c:1646  */
    {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6146 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2121 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6169 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2140 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6175 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2141 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6182 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2143 "cfg.y" /* yacc.c:1646  */
    {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6210 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2166 "cfg.y" /* yacc.c:1646  */
    {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6251 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2202 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6258 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2204 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6266 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2207 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6273 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2209 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6280 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2211 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6287 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2213 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6294 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2215 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6301 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2217 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6308 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2219 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6319 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2225 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-3].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)(long)i_tmp, (void*)(long)(yyvsp[-1].intval));
				}
#line 6330 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2231 "cfg.y" /* yacc.c:1646  */
    {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6341 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2237 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-1].action), (void*)(long)-1);
				}
#line 6350 "cfg.tab.c" /* yacc.c:1646  */
    break;


#line 6354 "cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2244 "cfg.y" /* yacc.c:1906  */


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
